package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.UserDictCat;
import com.sa.ibiz.demo.demo.domain.UserDict;

/**
 * 实体[UserDictItem] 数据对象
 */
@TableName(value = "T_SRFUSERDICTITEM",resultMap = "UserDictItemResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class UserDictItem extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private UserDictCat userdictcat;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private UserDict userdict;
    private String content;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private Integer markflag;
    private String memo;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String userdictcatid;
    @TableField(exist = false)//逻辑属性
    private String userdictcatname;
    private String userdictid;
    @TableId(value= "userdictitemid",type=IdType.UUID)//指定主键生成策略
    private String userdictitemid;
    private String userdictitemname;
    @TableField(exist = false)//逻辑属性
    private String userdictname;
    /**
     *  设置属性值[完整内容]
     *  @param content
     */
    public void setContent(String content){
        if(StringUtils.isEmpty(content))
            content=null;
        this.content = content;
        this.set("contentdirtyflag",true);
    }
    /**
     *  获取属性值[完整内容]
     */
    public String getContent(){
        return this.content;
    }
    /**
     *  重置属性值[完整内容]
     */
    public void resetContent(){
        this.set("contentdirtyflag",false);
        this.content = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[标记常用]
     *  @param markflag
     */
    public void setMarkflag(Integer markflag){
        this.markflag = markflag;
        this.set("markflagdirtyflag",true);
    }
    /**
     *  获取属性值[标记常用]
     */
    public Integer getMarkflag(){
        return this.markflag;
    }
    /**
     *  重置属性值[标记常用]
     */
    public void resetMarkflag(){
        this.set("markflagdirtyflag",false);
        this.markflag = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[词条类别]
     *  @param userdictcatid
     */
    public void setUserdictcatid(String userdictcatid){
        if(StringUtils.isEmpty(userdictcatid))
            userdictcatid=null;
        this.userdictcatid = userdictcatid;
        this.set("userdictcatiddirtyflag",true);
    }
    /**
     *  获取属性值[词条类别]
     */
    public String getUserdictcatid(){
        return this.userdictcatid;
    }
    /**
     *  重置属性值[词条类别]
     */
    public void resetUserdictcatid(){
        this.set("userdictcatiddirtyflag",false);
        this.userdictcatid = null;
    }
    /**
     *  设置属性值[词条类别]
     *  @param userdictcatname
     */
    public void setUserdictcatname(String userdictcatname){
        if(StringUtils.isEmpty(userdictcatname))
            userdictcatname=null;
        this.userdictcatname = userdictcatname;
        this.set("userdictcatnamedirtyflag",true);
    }
    /**
     *  获取属性值[词条类别]
     */
    public String getUserdictcatname(){
        return this.userdictcatname;
    }
    /**
     *  重置属性值[词条类别]
     */
    public void resetUserdictcatname(){
        this.set("userdictcatnamedirtyflag",false);
        this.userdictcatname = null;
    }
    /**
     *  设置属性值[用户词典]
     *  @param userdictid
     */
    public void setUserdictid(String userdictid){
        if(StringUtils.isEmpty(userdictid))
            userdictid=null;
        this.userdictid = userdictid;
        this.set("userdictiddirtyflag",true);
    }
    /**
     *  获取属性值[用户词典]
     */
    public String getUserdictid(){
        return this.userdictid;
    }
    /**
     *  重置属性值[用户词典]
     */
    public void resetUserdictid(){
        this.set("userdictiddirtyflag",false);
        this.userdictid = null;
    }
    /**
     *  设置属性值[用户词典词条标识]
     *  @param userdictitemid
     */
    public void setUserdictitemid(String userdictitemid){
        if(StringUtils.isEmpty(userdictitemid))
            userdictitemid=null;
        this.userdictitemid = userdictitemid;
        this.set("userdictitemiddirtyflag",true);
    }
    /**
     *  获取属性值[用户词典词条标识]
     */
    public String getUserdictitemid(){
        return this.userdictitemid;
    }
    /**
     *  重置属性值[用户词典词条标识]
     */
    public void resetUserdictitemid(){
        this.set("userdictitemiddirtyflag",false);
        this.userdictitemid = null;
    }
    /**
     *  设置属性值[词条名称]
     *  @param userdictitemname
     */
    public void setUserdictitemname(String userdictitemname){
        if(StringUtils.isEmpty(userdictitemname))
            userdictitemname=null;
        this.userdictitemname = userdictitemname;
        this.set("userdictitemnamedirtyflag",true);
    }
    /**
     *  获取属性值[词条名称]
     */
    public String getUserdictitemname(){
        return this.userdictitemname;
    }
    /**
     *  重置属性值[词条名称]
     */
    public void resetUserdictitemname(){
        this.set("userdictitemnamedirtyflag",false);
        this.userdictitemname = null;
    }
    /**
     *  设置属性值[用户词典]
     *  @param userdictname
     */
    public void setUserdictname(String userdictname){
        if(StringUtils.isEmpty(userdictname))
            userdictname=null;
        this.userdictname = userdictname;
        this.set("userdictnamedirtyflag",true);
    }
    /**
     *  获取属性值[用户词典]
     */
    public String getUserdictname(){
        return this.userdictname;
    }
    /**
     *  重置属性值[用户词典]
     */
    public void resetUserdictname(){
        this.set("userdictnamedirtyflag",false);
        this.userdictname = null;
    }
     /**
     *  获取主实体关联数据[UserDictCat]
     */
    public UserDictCat getUserdictcat() {
        return userdictcat;
    }
    /**
     *  设置主实体关联数据[UserDictCat]
     */
    public void setUserdictcat(UserDictCat userdictcat) {
        this.userdictcat = userdictcat;
    }

     /**
     *  获取主实体关联数据[UserDict]
     */
    public UserDict getUserdict() {
        return userdict;
    }
    /**
     *  设置主实体关联数据[UserDict]
     */
    public void setUserdict(UserDict userdict) {
        this.userdict = userdict;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetContent();
        resetCreatedate();
        resetCreateman();
        resetMarkflag();
        resetMemo();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetUpdatedate();
        resetUpdateman();
        resetUserdictcatid();
        resetUserdictcatname();
        resetUserdictid();
        resetUserdictitemid();
        resetUserdictitemname();
        resetUserdictname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public UserDictItem copyTo(UserDictItem targetEntity)
	{
		BeanCopier copier=BeanCopier.create(UserDictItem.class, UserDictItem.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetUserdictitemid();
		return targetEntity;
	}
}